#include <amxmodx>
#include <engine>
#include <fakemeta>
#include <hamsandwich>
#include <zombieplague>

new bool:g_awplevel1[33] = false
new bool:g_awplevel2[33] = false
new bool:g_awplevel3[33] = false
new g_kill[33]

new r_sprite, g_sprite, b_sprite, red_effect, green_effect, blue_effect
new cvar_frags_2lvl, cvar_frags_3lvl, damagelvl2, damagelvl3, cvar_nr

new awplvl3sprite

new const gibsound[] = "zombie_plague/zp_gibslay.wav"
new const awplvleffect[] = "zombie_plague/zp_awp_getlvl_effect.wav"
new AWPLEVEL2[] = "models/zombie_plague/zp_awp_lvl2.mdl"
new AWPLEVEL3[] = "models/zombie_plague/zp_awp_lvl3.mdl"
new P_AWPLEVEL2[] = "models/zombie_plague/zp_p_awp_lvl2.mdl"
new P_AWPLEVEL3[] = "models/zombie_plague/zp_p_awp_lvl3.mdl"

public plugin_init()
{
    register_plugin("[ZP] Awp Levelling", "1.1", "GAARA54")
    register_dictionary("zp_awp_levelling.txt")
    cvar_frags_2lvl = register_cvar("zp_awplvl2_frags", "3")
    cvar_frags_3lvl = register_cvar("zp_awplvl3_frags", "10")
    damagelvl2 = register_cvar("zp_multiple_damage_awplvl2", "2")
    damagelvl3 = register_cvar("zp_multiple_damage_awplvl3", "4")
    r_sprite = register_cvar("zp_awp_lvl3_red_sprite", "255")
    g_sprite = register_cvar("zp_awp_lvl3_green_sprite", "0")
    b_sprite = register_cvar("zp_awp_lvl3_blue_sprite", "0")
    red_effect = register_cvar("zp_lvl_effect_red", "255")
    green_effect = register_cvar("zp_lvl_effect_green", "255")
    blue_effect = register_cvar("zp_lvl_effect_blue", "255")
    cvar_nr = register_cvar("zp_remove_lvl_newround", "1")
    register_event("CurWeapon", "Event_CurWeapon", "be","1=1")
    register_event("HLTV", "event_round_start", "a", "1=0", "2=0")
    RegisterHam(Ham_Killed, "player", "fw_PlayerKilled")
    RegisterHam(Ham_TakeDamage, "player", "fw_TakeDamage")
    RegisterHam(Ham_TraceAttack, "worldspawn", "Trace_Attack", 1)
}

public plugin_precache()
{
	awplvl3sprite = precache_model("sprites/dot.spr")
	precache_model(AWPLEVEL2)
	precache_model(AWPLEVEL3)
	precache_model(P_AWPLEVEL2)
	precache_model(P_AWPLEVEL3)
	precache_sound(gibsound)
	precache_sound(awplvleffect)
}

public refresh()
{
    set_task(0.5, "event_round_start")
}

public event_round_start()
{
for (new i = 1; i <= get_maxplayers(); i++)
{
    if (get_pcvar_num(cvar_nr) > 0)
	{
        g_kill[i] = 0
        g_awplevel1[i] = true
        g_awplevel2[i] = false
        g_awplevel3[i] = false
	}
}
}

public zp_round_started(id)
{
for (new i = 1; i <= get_maxplayers(); i++)
{
    if (i == id)
	{
	if (get_pcvar_num(cvar_nr) > 0)
	{
        g_kill[id] = 0
        g_awplevel1[id] = true
        g_awplevel2[id] = false
        g_awplevel3[id] = false
	}
	}
}
}

public Event_CurWeapon(id)
{
    new weaponID = read_data(2)
	
    if (weaponID != CSW_AWP)
		return PLUGIN_CONTINUE
	
    if (g_awplevel1[id] == true && g_awplevel2[id] == false && g_awplevel3[id] == false)
    {
        set_pev(id, pev_viewmodel2, "models/v_awp.mdl")
        set_pev(id, pev_weaponmodel2, "models/p_awp.mdl")
    }
    if (g_awplevel1[id] == false && g_awplevel2[id] == true && g_awplevel3[id] == false)
    {
        set_pev(id, pev_viewmodel2, AWPLEVEL2)
        set_pev(id, pev_weaponmodel2, P_AWPLEVEL2)
    }
    if	(g_awplevel1[id] == false && g_awplevel2[id] == false && g_awplevel3[id] == true)
    {
        set_pev(id, pev_viewmodel2, AWPLEVEL3)
        set_pev(id, pev_weaponmodel2, P_AWPLEVEL3)
    }
    return PLUGIN_CONTINUE
}
	
	

public fw_PlayerKilled(victim, attacker, shouldgib)
{

	if (!zp_get_user_zombie(attacker) && zp_get_user_zombie(victim))
	{
		
		if (g_awplevel2[attacker] == false && g_awplevel3[attacker] == false)
		{
			g_awplevel1[attacker] = true
		}
		

		if (get_user_weapon(attacker) == CSW_AWP && g_awplevel1[attacker] == true)
		{
			g_kill[attacker] ++
			client_printcolor(attacker, "^4[ZP]^1 %L ^4(%d / %d)", LANG_PLAYER, "AWP_FRAGS_LVL2", g_kill[attacker], get_pcvar_num(cvar_frags_2lvl))
		}
		
		if (get_user_weapon(attacker) == CSW_AWP && g_awplevel2[attacker] == true)
		{
			g_kill[attacker] ++
			client_printcolor(attacker, "^4[ZP]^1 %L ^4(%d / %d)", LANG_PLAYER, "AWP_FRAGS_LVL3", g_kill[attacker], get_pcvar_num(cvar_frags_3lvl))
		}
		
		if (get_user_weapon(attacker) == CSW_AWP && g_awplevel3[attacker] == true)
		{
			SetHamParamInteger(3, 2)
			emit_sound(victim, CHAN_BODY, gibsound, 1.0, ATTN_NORM, 0, PITCH_NORM)
		}
		
		if (g_kill[attacker] == get_pcvar_num(cvar_frags_3lvl))
		{
			g_kill[attacker] ++
			g_awplevel1[attacker] = false
			g_awplevel2[attacker] = false
			g_awplevel3[attacker] = true
			client_printcolor(attacker, "^4[ZP]^1 %L", LANG_PLAYER, "GET_LVL3", get_pcvar_num(damagelvl3))
			effect(attacker)
		}
		else if (g_kill[attacker] == get_pcvar_num(cvar_frags_2lvl) && g_kill[attacker] < get_pcvar_num(cvar_frags_3lvl))
		{
			g_awplevel1[attacker] = false
			g_awplevel2[attacker] = true
			g_awplevel3[attacker] = false
			client_printcolor(attacker, "^4[ZP]^1 %L", LANG_PLAYER, "GET_LVL2", get_pcvar_num(damagelvl2))
			effect(attacker)
		}

		
	}

}

public fw_TakeDamage(victim, inflictor, attacker, Float:damage, damage_type)
{
for (new i = 1; i <= get_maxplayers(); i++)
{
	
	if (i == attacker)
	{
	
        if ((get_user_weapon(attacker) == CSW_AWP) && (g_awplevel1[attacker] == true) && (g_awplevel2[attacker] == false) && (g_awplevel3[attacker] == false))
	    {
            SetHamParamFloat(4, damage)
	    }
	
        if ((get_user_weapon(attacker) == CSW_AWP)&& (g_awplevel1[attacker] == false) && (g_awplevel2[attacker] == true) && (g_awplevel3[attacker] == false))
	    {
            SetHamParamFloat(4, damage * get_pcvar_num(damagelvl2))
	    }
	
        if ((get_user_weapon(attacker) == CSW_AWP)&& (g_awplevel1[attacker] == false) && (g_awplevel2[attacker] == false) && (g_awplevel3[attacker] == true))
	    {
            SetHamParamFloat(4, damage * get_pcvar_num(damagelvl3))
	    }
	
	}
	
}
}

public Trace_Attack(this, id, Float:damage, Float:direction[3], tracehandle, damagebits)
{	
		if (get_user_weapon(id) == CSW_KNIFE || g_awplevel1[id] == true || g_awplevel2[id] == true)
		{
			return HAM_SUPERCEDE;
		}
		else if(get_user_weapon(id) == CSW_AWP && (g_awplevel3[id] == true))
		{
			static origin[3], Float:end[3]
			get_user_origin(id, origin, 1)
			get_tr2(tracehandle, TR_vecEndPos, end)
			
			message_begin( MSG_BROADCAST,SVC_TEMPENTITY)
			write_byte (0)     //TE_BEAMENTPOINTS 0
			write_coord(origin[0])
			write_coord(origin[1])
			write_coord(origin[2])
			engfunc(EngFunc_WriteCoord, end[0])
			engfunc(EngFunc_WriteCoord, end[1]) 
			engfunc(EngFunc_WriteCoord, end[2]) 
			write_short( awplvl3sprite )
			write_byte(1)
			write_byte(5)
			write_byte(2)
			write_byte(10)
			write_byte(0)
			write_byte(get_pcvar_num(r_sprite))
			write_byte(get_pcvar_num(g_sprite))
			write_byte(get_pcvar_num(b_sprite))
			write_byte(200)
			write_byte(150)
			message_end()
		}

		return FMRES_IGNORED
}

public effect(attacker)
{
	static Float:originF[3]
	pev(attacker, pev_origin, originF)

	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(TE_DLIGHT);
	engfunc(EngFunc_WriteCoord, originF[0]); // x
	engfunc(EngFunc_WriteCoord, originF[1]); // y
	engfunc(EngFunc_WriteCoord, originF[2]); // z
	write_byte(25); // radius
	write_byte(get_pcvar_num(red_effect)); // r
	write_byte(get_pcvar_num(green_effect)); // g
	write_byte(get_pcvar_num(blue_effect)); // b
	write_byte(8); // life
	write_byte(60); // decay rate
	message_end()
	
	emit_sound(attacker, CHAN_BODY, awplvleffect, 1.0, ATTN_NORM, 0, PITCH_NORM)
}

stock client_printcolor(const id, const input[], any:...)
{
	new iCount = 1, iPlayers[32]
	static szMsg[191]

	vformat(szMsg, charsmax(szMsg), input, 3)
	replace_all(szMsg, 190, "/g", "^4")
	replace_all(szMsg, 190, "/y", "^1")
	replace_all(szMsg, 190, "/ctr", "^1")
	replace_all(szMsg, 190, "/w", "^0")

	if(id) iPlayers[0] = id
	else get_players(iPlayers, iCount, "ch")
	for (new i = 0; i < iCount; i++)
	{
		if(is_user_connected(iPlayers[i]))
		{
			message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), _, iPlayers[i])
			write_byte(iPlayers[i])
			write_string(szMsg)
			message_end()
		}
	}
}